Index: apps/app_voicemail.c
===================================================================
--- apps/app_voicemail.c	(revision 262898)
+++ apps/app_voicemail.c	(working copy)
@@ -1946,6 +1946,8 @@
 		return 8;
 	else if (!strcasecmp(folder, "Cust5"))
 		return 9;
+	else if (!strcasecmp(folder, "Urgent"))
+		return 11;
 	else /*assume they meant INBOX if folder is not found otherwise*/
 		return 0;
 }
@@ -1997,13 +1999,13 @@
 	}
 	if (vms_p) {
 		ast_debug(3, "Returning before search - user is logged in\n");
-		if (fold == 0) { /* INBOX */
+		if (fold == 0 && urgent == 0) { /* INBOX */
 			return vms_p->newmessages;
 		}
 		if (fold == 1) { /* Old messages */
 			return vms_p->oldmessages;
 		}
-		if (fold == 11) {/*Urgent messages*/
+		if (fold == 0 && urgent == 1) {/*Urgent messages*/
 		 	return vms_p->urgentmessages;
 		}
 	}
@@ -2031,6 +2033,8 @@
 		if (fold != 1) {
 			pgm->unseen = 1;
 			pgm->seen = 0;
+			pgm->flagged = 0;
+			pgm->unflagged = 1;
 		}
 		/* In the special case where fold is 1 (old messages) we have to do things a bit
 		 * differently. Old messages are stored in the INBOX but are marked as "seen"
